---

# global settings
image: alpine:latest

stages:
  - unit tests
  - integration tests

unit tests:
  stage: unit tests
  before_script:
    - adduser -D build
  script:
    - .ci/run.sh
  artifacts:
    expire_in: 1 week

integration test:
  stage: integration tests
  before_script:
    - apk add curl android-tools file
    - apk add --allow-untrusted -X http://mirror.postmarketos.org/postmarketos/master/ mkbootimg-osm0sis
    # Force IPv4 for gitlab.postmarketos.org until it supports IPv6 too, OSUOSL is
    # working on it (infra#195)
    - "echo '140.211.167.182 gitlab.postmarketos.org' >> /etc/hosts"
    - curl -4fsSL "https://gitlab.postmarketos.org/postmarketOS/ci-common/-/raw/master/install_pmbootstrap.sh" | sh
    - su pmos -c "pmbootstrap config device ${DEVICE}"
    - su pmos -c "pmbootstrap config ui none"
  script:
    - su pmos -c .ci/integration_test.sh
  after_script:
    - cp /home/pmos/.local/var/pmbootstrap/log.txt $CI_PROJECT_DIR
  artifacts:
    when: on_failure
    expire_in: 1 week
    paths:
      - log.txt
      - work/
      - boot/
      - bootimg_extract/
  parallel:
    # NOTE: the pinephone isn't here because boot-deploy is pretty much just a nop
    # on that device.
    matrix:
      # Android device with appended DTB and standard boot.img
      - DEVICE: oneplus-enchilada
      # Chromebook with depthcharge image (creates /boot/vmlinuz.kpart)
      - DEVICE: google-veyron
      # ThinkPad x13s generates systemd-boot config
      - DEVICE: lenovo-21bx
      # Another standard Android device, but an msm8916 one
      - DEVICE: samsung-a5
      # Android device with a boot.img containing an exynos QCDT image
      - DEVICE: samsung-on7xelte
      # extlinux
      - DEVICE: pine64-pinebookpro
      # sd-boot + CPU microcode config
      - DEVICE: generic-x86_64
